public class Knoten extends Baumelement{
    // Attribute
    public int daten;
    public Baumelement linkerKnoten;
    public Baumelement rechterKnoten;

    //Konstruktor
    public Knoten() {
        daten = -1;
        linkerKnoten = new Abschluss();
        rechterKnoten = new Abschluss();
    }

    public Knoten(int newDaten) {
        daten = newDaten;
        linkerKnoten = new Abschluss();
        rechterKnoten = new Abschluss();
    }

    public Knoten(int newDaten, Baumelement knotenLinks, Baumelement knotenRechts) {
        daten = newDaten;
        linkerKnoten = knotenLinks;
        rechterKnoten = knotenRechts;
    }
    //Methoden und Dienste
     public Knoten insert(int newDaten) {
         if (newDaten<daten) linkerKnoten = linkerKnoten.insert(newDaten);
         else if (newDaten>daten) rechterKnoten = rechterKnoten.insert(newDaten);
         return this;
    }
    
    Boolean istKnoten() { return true; }
    Boolean istAbschluss() { return false; }

    
    public Baumelement delete(int daten) {  
        if (daten==this.daten) {
            //Dieser Knoten muss gelscht werden
            
            
            if (linkerKnoten.istKnoten() && rechterKnoten.istKnoten()) {
                //Fall 1: Zwei Nachfolger
                //Ersetze den Inhalt des zu lschenden Knotens durch den grten Wert des linken Teilbaums 
                //oder alternativ durch den kleinsten Wert des rechten Teilbaumes. 
                //Lsche anschlieend den entsprechenden Knoten mit der bei Fall 1 bzw. Fall 2 beschriebenen Methode.
                
                //getMin() kann mit rechterKnoten als Parameter aufgerufen werden,
                //da garantiert ist, das im rechten Teilbaum mindestens ein Knoten ist.

                //Suche das kleinste Element im rechten Teilbaum
                //und ersetze 
                this.daten = rechterKnoten.getMin(daten);
                rechterKnoten.delete(this.daten);
                return this;
            } else {
                if (linkerKnoten.istAbschluss() && rechterKnoten.istAbschluss()) {
                    //Fall 3: Der aktuelle Knoten ist ein Blatt und kann problemlos gelscht werden
                    return new Abschluss();
                } else {
                    //Fall 2: Nur einen Nachfolger
                    //Hier muss der left- bzw. der right-Zeiger des Vorgngerknotens 
                    //auf den Nachfolger des zu lschenden Knotens gesetzt werden.
                    if (linkerKnoten.istKnoten()) return linkerKnoten;
                    else return rechterKnoten;
                }
            }
        } else {
            //Aufruf weitergeben
            if (daten>this.daten) {
                //Lschaufruf weitergeben
                rechterKnoten = rechterKnoten.delete(daten);
            } else {
                linkerKnoten = linkerKnoten.delete(daten);
            }
        }
        return this;
    }


    public void inorder() {
        linkerKnoten.inorder();
        System.out.println(daten);
        rechterKnoten.inorder();
    }

    public void postorder() {
        linkerKnoten.inorder();
        rechterKnoten.inorder();
        System.out.println(daten);
    }

    public void preorder() {
        System.out.println(daten);
        linkerKnoten.inorder();
        rechterKnoten.inorder();
    }

    public boolean suchen(int zahl) {
        if (zahl<daten) return linkerKnoten.suchen(zahl);
        else if (zahl>daten) return rechterKnoten.suchen(zahl);
        return true;
    }

    public int getMin(int wertvomVater) {
        //Man findet bei einem Suchbaum immer das Min im rechten Teilbaum,
        //Wenn ich bei jedem Knoten ab diesem nach links gehe.
        //Wenn ich dann in einem Abschluss lande, war der letzte Knoten das Minimum
        return linkerKnoten.getMin(daten);
    }
}
